1. 程式人生 > >HDU5534 Partial Tree(完全揹包,思路)

HDU5534 Partial Tree(完全揹包,思路)

Problem Description

In mathematics, and more specifically in graph theory, a tree is an undirected graph in which any two nodes are connected by exactly one path. In other words, any connected graph without simple cycles is a tree.

You find a partial tree on the way home. This tree has n nodes but lacks of n−1 edges. You want to complete this tree by adding n−1 edges. There must be exactly one path between any two nodes after adding. As you know, there are nn−2 ways to complete this tree, and you want to make the completed tree as cool as possible. The coolness of a tree is the sum of coolness of its nodes. The coolness of a node is f(d), where f is a predefined function and d is the degree of this node. What’s the maximum coolness of the completed tree?

Input

The first line contains an integer T indicating the total number of test cases. Each test case starts with an integer n in one line, then one line with n−1 integers f(1),f(2),…,f(n−1).

1≤T≤2015 2≤n≤2015 0≤f(i)≤10000 There are at most 10 test cases with n>100.

Output

For each test case, please output the maximum coolness of the completed tree in one line.

Sample Input

2
3
2 1
4
5 1 4

Sample Output

5
19

思路

讓你構造一個有n(2n2015)n(2≤n≤2015)個節點的樹。 然後定義這棵樹的coolnesscoolnessf(d)\sum{f(d)},其中dd是每個節點的度數,函式f(d)f(d)在輸入中給出。

一顆含有nn個節點的樹,有n1n−1條邊,度數之和為2n22n−2。轉化成揹包問題可以這樣描述:揹包的容量為2n22n−2,我們要恰好選nn個物品而且要恰好裝滿揹包。體積為ii的物品的價值為f

(i)f(i),而且每種物品有無窮多個

我們可以想到一個二維的做法。

dp[i][j],表示前i個物品,體積為j所能達到的最大權值。但是這樣是O(n3)O(n^3)的。

我們可以改變一下思路,因為這n個物品必須選,所以可以先給這n個節點,每一個節點都先給一個度,因為度數總數是2n22n-2,那麼給了之後就變成了n2n-2.

我們再把這n2n-2個度數進行完全揹包,因為已經用了一個度數,所以要給其他的f[i]-=f[0].

程式碼

#include <bits/stdc++.h>
using namespace std;
#define mem(a, b) memset(a, b, sizeof(a))
#define inf 0x3f3f3f
const int N = 1e4 + 10;
double eps = 1e-5;

int dp[N], f[N];
int main()
{
    //freopen("in.txt", "r", stdin);
    int t, n, m;
    scanf("%d", &t);
    while (t--)
    {
        scanf("%d", &n);
        m = n - 2;
        for (int i = 0; i <= n - 2; i++)
            scanf("%d", &f[i]);
        for (int i = 1; i <= n - 2; i++)
            f[i] -= f[0];
        mem(dp, 0);
        dp[0] = f[0] * n;

        for (int i = 1; i <= n - 2; i++)
            for (int j = i; j <= m; j++)
                dp[j] = max(dp[j], dp[j - i] + f[i]);
        printf("%d\n", dp[m]);
    }
    return 0;
}